# Retrieve, Update, or Delete User Quest PATCH /api/v1/quests/my-quests/{quest_id}/ Content-Type: application/json Retrieve, update, or delete a specific IAMUserQuest object for the authenticated user by quest ID. Reference: https://docs.aisquare.studio/api-reference/ai-square-studio-api/quests/my-quests-retrieve ## OpenAPI Specification ```yaml openapi: 3.1.0 info: title: AISquare Studio API version: 1.0.0 paths: /api/v1/quests/my-quests/{quest_id}/: patch: operationId: my-quests-partial-update summary: Retrieve, Update, or Delete User Quest description: >- Retrieve, update, or delete a specific IAMUserQuest object for the authenticated user by quest ID. tags: - subpackage_quests parameters: - name: quest_id in: path description: The ID of the quest required: true schema: type: integer responses: '200': description: User quest details content: application/json: schema: $ref: '#/components/schemas/IAMUserQuest' '400': description: Invalid input content: application/json: schema: description: Any type '401': description: Unauthorized content: application/json: schema: description: Any type '403': description: Permission denied content: application/json: schema: description: Any type '404': description: User quest not found content: application/json: schema: description: Any type requestBody: content: application/json: schema: $ref: '#/components/schemas/PatchedIAMUserQuest' components: schemas: MinimalIAMUserDetail: type: object properties: profile_picture: type: - string - 'null' format: uri bio: type: - string - 'null' country: type: - string - 'null' phone: type: - string - 'null' linkedin_url: type: - string - 'null' format: uri github_url: type: - string - 'null' format: uri twitter_url: type: - string - 'null' format: uri website_url: type: - string - 'null' format: uri top_domain_elo: type: number format: double top_domain_rank: type: integer required: - profile_picture - bio - country - phone - linkedin_url - github_url - twitter_url - website_url - top_domain_elo - top_domain_rank title: MinimalIAMUserDetail MinimalIAMUser: type: object properties: id: type: integer username: type: string description: >- Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only. email: type: string format: email full_name: type: string is_verified: type: boolean details: type: array items: $ref: '#/components/schemas/MinimalIAMUserDetail' followers_count: type: integer required: - id - username - email - full_name - is_verified - details - followers_count title: MinimalIAMUser MinimalPlayerLevel: type: object properties: id: type: integer uid: type: string format: uuid name: type: string description: type: - string - 'null' avg_score: type: integer required: - id - uid - name description: Minimal serializer for PlayerLevel to be used in other modules title: MinimalPlayerLevel MinimalQuest: type: object properties: id: type: integer uid: type: string format: uuid name: type: string summary: type: - string - 'null' logo: type: - string - 'null' format: uri cover: type: - string - 'null' format: uri player_level: $ref: '#/components/schemas/MinimalPlayerLevel' created_by: $ref: '#/components/schemas/MinimalIAMUser' co_creators: type: array items: $ref: '#/components/schemas/MinimalIAMUser' user_added_quest: type: boolean description: Check if the current user has added this quest workspace_id: type: integer required: - id - uid - name - player_level - created_by - co_creators - user_added_quest - workspace_id description: Mixin to add user_added_quest field to quest serializers title: MinimalQuest GlobalCreationStatusEnum: type: string enum: - not_started - in_progress - completed - failed description: |- * `not_started` - Not Started * `in_progress` - In Progress * `completed` - Completed * `failed` - Failed title: GlobalCreationStatusEnum PatchedIAMUserQuest: type: object properties: id: type: integer uid: type: string format: uuid user: $ref: '#/components/schemas/MinimalIAMUser' quest: type: integer quest_details: $ref: '#/components/schemas/MinimalQuest' created_at: type: string format: date-time updated_at: type: string format: date-time progress_percent: type: number format: double progress: description: Any type score: type: number format: double status: $ref: '#/components/schemas/GlobalCreationStatusEnum' completion_date: type: - string - 'null' format: date-time certification_available: type: boolean title: PatchedIAMUserQuest IAMUserQuest: type: object properties: id: type: integer uid: type: string format: uuid user: $ref: '#/components/schemas/MinimalIAMUser' quest: type: integer quest_details: $ref: '#/components/schemas/MinimalQuest' created_at: type: string format: date-time updated_at: type: string format: date-time progress_percent: type: number format: double progress: description: Any type score: type: number format: double status: $ref: '#/components/schemas/GlobalCreationStatusEnum' completion_date: type: - string - 'null' format: date-time certification_available: type: boolean required: - id - uid - user - quest - quest_details - created_at - updated_at title: IAMUserQuest ``` ## SDK Code Examples ```python import requests url = "https://api.example.com/api/v1/quests/my-quests/1/" payload = {} headers = {"Content-Type": "application/json"} response = requests.patch(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.example.com/api/v1/quests/my-quests/1/'; const options = {method: 'PATCH', headers: {'Content-Type': 'application/json'}, body: '{}'}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.example.com/api/v1/quests/my-quests/1/" payload := strings.NewReader("{}") req, _ := http.NewRequest("PATCH", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.example.com/api/v1/quests/my-quests/1/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Patch.new(url) request["Content-Type"] = 'application/json' request.body = "{}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.patch("https://api.example.com/api/v1/quests/my-quests/1/") .header("Content-Type", "application/json") .body("{}") .asString(); ``` ```php request('PATCH', 'https://api.example.com/api/v1/quests/my-quests/1/', [ 'body' => '{}', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.example.com/api/v1/quests/my-quests/1/"); var request = new RestRequest(Method.PATCH); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = [] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/api/v1/quests/my-quests/1/")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PATCH" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ```python import requests url = "https://api.example.com/api/v1/quests/my-quests/1/" payload = {} headers = {"Content-Type": "application/json"} response = requests.patch(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.example.com/api/v1/quests/my-quests/1/'; const options = {method: 'PATCH', headers: {'Content-Type': 'application/json'}, body: '{}'}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.example.com/api/v1/quests/my-quests/1/" payload := strings.NewReader("{}") req, _ := http.NewRequest("PATCH", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.example.com/api/v1/quests/my-quests/1/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Patch.new(url) request["Content-Type"] = 'application/json' request.body = "{}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.patch("https://api.example.com/api/v1/quests/my-quests/1/") .header("Content-Type", "application/json") .body("{}") .asString(); ``` ```php request('PATCH', 'https://api.example.com/api/v1/quests/my-quests/1/', [ 'body' => '{}', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.example.com/api/v1/quests/my-quests/1/"); var request = new RestRequest(Method.PATCH); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = [] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/api/v1/quests/my-quests/1/")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PATCH" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```